//this file is part of eMule Xtreme-Mod (http://www.xtreme-mod.net)
//Copyright (C)2002-2007 Xtreme-Mod (emulextreme@yahoo.de)

//emule Xtreme is a modification of eMule
//Copyright (C)2002-2007 Merkur ( strEmail.Format("%s@%s", "devteam", "emule-project.net") / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//
//
//	Author: Xman 
//  





#include "stdafx.h"
#include "DLP.h"
#include "Log.h"
#include "antiLeech.h"
#include "Preferences.h" // X: [DLPI] - [DLP Integerated]
//X-Ray :: Fincan Hash Detection :: Start
#include "opcodes.h"
#include "resource.h"
#include "friend.h"
#include "OtherFunctions.h"
#include "HttpDownloadDlg.h"
#include "SafeFile.h"
#include "emule.h"
//X-Ray :: Fincan Hash Detection :: End

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CDLP::CDLP(/*CString appdir_in*/)
{
	//appdir=appdir_in;

	//dlpavailable=false;// X: [DLPI] - [DLP Integerated]
	dlpInstance=NULL;
	Reload();
}

CDLP::~CDLP()
{
	if(dlpInstance!=NULL)
	{
		::FreeLibrary(dlpInstance);
	}
	if(thePrefs.isIntegeratedDLP) // X: [CDLP] - [Compressed DLP]
		_DLPOnUnLoad();
}

void CDLP::LoadDefault(){// X: [DLPI] - [DLP Integerated]
	if(_DLPOnLoad()){ // X: [CDLP] - [Compressed DLP]
		GetDLPVersion = _GetDLPVersion;
		DLPCheckModstring_Hard = _DLPCheckModstring_Hard;
		DLPCheckModstring_Soft = _DLPCheckModstring_Soft;

		DLPCheckUsername_Hard = _DLPCheckUsername_Hard;
		DLPCheckUsername_Soft = _DLPCheckUsername_Soft;

		DLPCheckNameAndHashAndMod = _DLPCheckNameAndHashAndMod;

		DLPCheckMessageSpam = _DLPCheckMessageSpam;
		DLPCheckUserhash = _DLPCheckUserhash;

		DLPCheckHelloTag = _DLPCheckHelloTag;
		DLPCheckInfoTag = _DLPCheckInfoTag;
		//dlpavailable=true;// X: [DLPI] - [DLP Integerated]
		thePrefs.isIntegeratedDLP = true;
		AddLogLine(false,_T("Dynamic Anti-Leecher Protection v %u loaded"), GetDLPVersion());
	}
}

void CDLP::Reload()
{
	//dlpavailable=false;// X: [DLPI] - [DLP Integerated]
	CString appdir=thePrefs.GetMuleDirectory(EMULE_EXECUTEABLEDIR);

#ifndef _WIN64
	CString newdll = appdir + _T("antiLeech.dll.new");
	CString olddll = appdir + _T("antiLeech.dll.old");
	CString currentdll = appdir + _T("antiLeech.dll");
#else
	CString newdll = appdir + _T("antiLeechx64.dll.new");
	CString olddll = appdir + _T("antiLeechx64.dll.old");
	CString currentdll = appdir + _T("antiLeechx64.dll");
#endif

	if(PathFileExists(newdll))
	{
		AddLogLine(false,_T("found new version of antiLeech.dll"));
		//new version exists, try to unload the old and load the new one
		if(dlpInstance!=NULL)
		{
			::FreeLibrary(dlpInstance);
			dlpInstance=NULL;
		}
		if(PathFileExists(currentdll)?
			((PathFileExists(olddll) && _tremove(olddll)!=0) || _trename(currentdll,olddll)!=0):_trename(newdll,currentdll)!=0){
			AddLogLine(false,_T("error during copying the antiLeech.dll's, try to load the old one"));
		}
	}

	if(dlpInstance==NULL)
	{
		if(PathFileExists(currentdll)){
			dlpInstance=::LoadLibrary(currentdll);
			if(dlpInstance!=NULL)
			{
				//testfunc = (TESTFUNC)GetProcAddress(dlpInstance,("TestFunc"));
				GetDLPVersion = (GETDLPVERSION)GetProcAddress(dlpInstance,("GetDLPVersion"));
				DLPCheckModstring_Hard = (DLPCHECKMODSTRING_HARD)GetProcAddress(dlpInstance,("DLPCheckModstring_Hard"));
				DLPCheckModstring_Soft = (DLPCHECKMODSTRING_SOFT)GetProcAddress(dlpInstance,("DLPCheckModstring_Soft"));

				DLPCheckUsername_Hard = (DLPCHECKUSERNAME_HARD)GetProcAddress(dlpInstance,("DLPCheckUsername_Hard"));
				DLPCheckUsername_Soft = (DLPCHECKUSERNAME_SOFT)GetProcAddress(dlpInstance,("DLPCheckUsername_Soft"));

				DLPCheckNameAndHashAndMod = (DLPCHECKNAMEANDHASHANDMOD)GetProcAddress(dlpInstance,("DLPCheckNameAndHashAndMod"));

				DLPCheckMessageSpam = (DLPCHECKMESSAGESPAM)GetProcAddress(dlpInstance,("DLPCheckMessageSpam"));
				DLPCheckUserhash = (DLPCHECKUSERHASH)GetProcAddress(dlpInstance,("DLPCheckUserhash"));

				DLPCheckHelloTag = (DLPCHECKHELLOTAG)GetProcAddress(dlpInstance,("DLPCheckHelloTag"));
				DLPCheckInfoTag = (DLPCHECKINFOTAG)GetProcAddress(dlpInstance,("DLPCheckInfoTag"));
				if( GetDLPVersion &&
					DLPCheckModstring_Hard &&
					DLPCheckModstring_Soft &&
					DLPCheckUsername_Hard &&
					DLPCheckUsername_Soft &&
					DLPCheckNameAndHashAndMod &&
					DLPCheckHelloTag &&
					DLPCheckInfoTag &&
					DLPCheckMessageSpam &&
					DLPCheckUserhash
					)
				{
					if(!thePrefs.dontCheckDLPVer
						&&((GetDLPVersion()>DLPVERSION && GetDLPVersion()<1000)
						||GetDLPVersion()>DLPVERSION * 100))
					{// X: load DLP+ version larger than 3700 only
						//dlpavailable=true;// X: [DLPI] - [DLP Integerated]
						if(thePrefs.isIntegeratedDLP){
							_DLPOnUnLoad();
							thePrefs.isIntegeratedDLP = false;
						}
						AddLogLine(false,_T("Dynamic Anti-Leecher Protection v %u loaded"), GetDLPVersion());
						if(thePrefs.dontUp2Leecher)
							AddLogLine(false,_T("\"Don't upload to leecher\" will be disabled"));
						return;
					}
					AddLogLine(false,_T("The DLP loaded(v %u) is not newer. kept the default one"), GetDLPVersion());
					::FreeLibrary(dlpInstance);
					dlpInstance=NULL;
				}
				else
				{
					LogError(_T("Failed to initialize the antiLeech.dll, please use an up to date version of DLP"));
					::FreeLibrary(dlpInstance);
					dlpInstance=NULL;
				}
			}
			else
				LogError(_T("Failed to load the antiLeech.dll, ErrorCode: %u"), GetLastError());
		}
		LoadDefault();// X: [DLPI] - [DLP Integerated]
	}
	else
	{
		AddDebugLogLine(false,_T("no new version of antiLeech.dll found. kept the old one"));
		//dlpavailable=true;// X: [DLPI] - [DLP Integerated]
	}
}

//X-Ray :: Fincan Hash Detection :: Start
bool CDLP::CheckForFincanHash(const uchar* hash) const
{
	return !m_FincanHashList.empty() && (m_FincanHashList.count(hash) > 0);
}

void CDLP::LoadFincanHashes(CString strURL, bool forced)
{
	CString strFilename;
	strFilename.Format(L"%sFincanHashes.met", thePrefs.GetMuleDirectory(EMULE_CONFIGDIR));
	if(strURL.IsEmpty()) 
		strURL = L"http://www.e-sipa.de/fincan/emfriends.met";
	else if(strURL.Find(L"://") == -1){ // not a valid URL
		AddLogLine(true, L"%s: %s", GetResString(IDS_INVALIDURL), strURL);
		return;
	}
	if(!forced)
	{
		if(PathFileExists(strFilename) && thePrefs.m_last_fincan_check!=0) {
			CTime last(thePrefs.m_last_fincan_check);
			struct tm tmTemp;
			time_t tLast=safe_mktime(last.GetLocalTm(&tmTemp));
			time_t tNow=safe_mktime(CTime::GetCurrentTime().GetLocalTm(&tmTemp));
			if ( (difftime(tNow,tLast) / 86400)<thePrefs.GetUpdateDays() )
				return;
		}

		theApp.SplashHide(); //Xman new slpash-screen arrangement
	}


	CString strTempFilename = strFilename + _T(".tmp");

	CHttpDownloadDlg dlgDownload;
	dlgDownload.m_strTitle = L"Downloading Fincan emfirends.met";
	dlgDownload.m_sURLToDownload = strURL;
	dlgDownload.m_sFileToDownloadInto = strTempFilename;

	SYSTEMTIME SysTime;
	if (PathFileExists(strFilename))
		memcpy(&SysTime, &thePrefs.m_FincanVersion, sizeof(SYSTEMTIME));
	else
		memset(&SysTime, 0, sizeof(SYSTEMTIME));
	dlgDownload.m_pLastModifiedTime = &SysTime; //Xman remark: m_pLastModifiedTime is a pointer which points to the SysTime-struct

	if (dlgDownload.DoModal() != IDOK){
		AddDebugLogLine(false, L"Failed to load Fincan emfriends.met!");
		return;
	}
	struct tm tmTemp;
	thePrefs.m_last_fincan_check = safe_mktime(CTime::GetCurrentTime().GetLocalTm(&tmTemp));
	if (dlgDownload.m_pLastModifiedTime == NULL)
		return;

	_tremove(strFilename);
	_trename(strTempFilename, strFilename);

	FincanHashSet().swap(m_FincanHashList);

	CSafeBufferedFile file;
	CFileException fexp;
	if (!file.Open(strFilename, CFile::modeRead | CFile::osSequentialScan | CFile::typeBinary | CFile::shareDenyWrite, &fexp)){
		if (fexp.m_cause != CFileException::fileNotFound){
			CString strError(GetResString(IDS_ERR_READEMFRIENDS));
			TCHAR szError[MAX_CFEXP_ERRORMSG];
			if (fexp.GetErrorMessage(szError, _countof(szError)))
				strError.AppendFormat(L" - %s", szError);
			AddDebugLogLine(false, L"%s", strError);
		}
		return;
	}

	try {
		uint8 header = file.ReadUInt8();
		if (header != MET_HEADER){
			file.Close();
			return;
		}

		UINT nRecordsNumber = file.ReadUInt32();
		CFriend Record;
		for (UINT i = 0; i < nRecordsNumber; ++i){
			Record.LoadFromFile(&file, false);
			if(Record.HasUserhash()){
				const uchar* hash = Record.m_abyUserhash;
				if(m_FincanHashList.count(hash) == 0)
					m_FincanHashList.insert(hash);
			}
		}
		file.Close();
	}

	catch(CFileException* error){
		if (error->m_cause == CFileException::endOfFile)
			AddDebugLogLine(false, GetResString(IDS_ERR_EMFRIENDSINVALID));
		else {
			TCHAR buffer[MAX_CFEXP_ERRORMSG];
			error->GetErrorMessage(buffer, _countof(buffer));
			AddDebugLogLine(false, GetResString(IDS_ERR_READEMFRIENDS), buffer);
		}
		error->Delete();
		return;
	}

	if(!m_FincanHashList.empty())
	{
		memcpy(&thePrefs.m_FincanVersion, &SysTime, sizeof SysTime); 
		AddDebugLogLine(false, L"Loaded %u Fincan Userhashes!", m_FincanHashList.size());
	}
}
//X-Ray :: Fincan Hash Detection :: End