#pragma once
#include "shahashset.h"
struct SSearchParams;

namespace Json{
	class CJsonParser;
	struct Value;
	enum EKey{
		KNone = 0,
		KName,
		KHash,
		KAICHHash,
		KSize,
		KSource,
		KCompletedSource,
		KRecordPlus,
		KRecordMinus,
		KRecordArray
	};

	struct SearchRecord{
		char* sName;
		//char* sExt;
		//char* sTime;
		bool hasICH;
		bool hasAICH;
		uchar sHash[16];
		uchar sAich[HASHSIZE];
		uint64 iSize;
		//uint32 iStatus;
		uint32 iSource;
		uint32 iCompletedSource;
		SearchRecord(){memset(this, 0, sizeof(SearchRecord));}
		void reset(){
			delete [] sName;
			//delete [] sExt;
			//delete [] sTime;
			memset(this, 0, sizeof(SearchRecord));
		}
		~SearchRecord(){reset();}
	};
	class Context{
	public:
		Context(uint32 _nSearchID)
			: jp(NULL)
			, key(KNone)
			, nSearchID(_nSearchID)
			, rest(0)
		{
		}
		CJsonParser*jp;
		EKey key;
		uint32 nSearchID;
		SearchRecord curRecord;
		int rest;
	};

	// X: [JFS] - [JSON Format Search]
	class JsonSearchThread : public Poco::Thread
	{
	public:
		virtual void run();
		SSearchParams* pParams;
	};
}
