﻿//DLP = Dynamic Leecher Protection
//this code is part of Xtreme-Mod
//author: Xman

//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


#include "stdafx.h"
//#include <atlstr.h>
#include "antiLeech.h"
#include "otherfunctions.h"
#include <zlib/zlib.h> // X: [CDLP] - [Compressed DLP]

//#define USE_SHLWAPI

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#ifndef USE_SHLWAPI
#define StrStrW wcsstr
#define StrStrIW wcsistr
#define StrCmpIW _wcsicmp
#endif

//>>> eWombat [SNAFU_V3]
const LPCTSTR apszSnafuTag[]=
{
	_T("[DodgeBoards]"),									//0
	_T("[DodgeBoards & DarkMule eVorteX]"),					//1
	_T("[DarkMule v6 eVorteX]"),							//2
	_T("[eMuleReactor]"),									//3
	_T("[Bionic]"),											//4
	_T("[LSD7c]"),											//5
	_T("[0x8d] unknown Leecher - (client version:60)"),		//6
	_T("[RAMMSTEIN]"),										//7
	_T("[MD5 Community]"),									//8
	_T("[new DarkMule]"),									//9
	_T("[OMEGA v.07 Heiko]"),								//10
	_T("[eMule v0.26 Leecher]"),							//11
	_T("[Hunter]"),											//12
	_T("[Bionic 0.20 Beta]"),								//13
	_T("[Rumata (rus)(Plus v1f)]"),							//14
	_T("[Fusspi]"),											//15
	_T("[donkey2002]"),										//16
	_T("[md4]"),									        //17
	_T("[SpeedMule]"),										//18 Xman 
	_T("[pimp]")											//19 Xman 
	,_T("[Chinese Leecher]")								//20 SquallATF
	//,_T("[eChanblardNext]")								//21 zz_fly
};
// X: [CDLP] - [Compressed DLP]
static TCHAR*__s = NULL;
static LPCTSTR* S_array;

#include "antiLeech.inc.h"

BOOL _DLPOnLoad(){
	if(__s) return TRUE;
	__s = new TCHAR[SIGNATURESTRINGLEN];
	unsigned long unpacksize = SIGNATURESTRINGLEN*sizeof(TCHAR);
	if(uncompress((Bytef *)__s, &unpacksize, __sZ, _countof(__sZ)) != Z_OK){
		_DLPOnUnLoad();
		return FALSE;
	}
	S_array = new LPCTSTR[SC_array];
	LPCTSTR start = __s;
	for (size_t i = 0; i < SC_array; ++i)
	{
		S_array[i] = start;
		start += _tcslen(start) + 1;
	}
	ASSERT(!_tcscmp(S_ModstringHard[0], _T("TM0910")));
	ASSERT(!_tcscmp(S_ModstringHardFake[0], _T("NetF WARP 9")));
	ASSERT(!_tcscmp(S_ModstringHardI[0], _T("fxemule")));
	ASSERT(!_tcscmp(S_ModstringSoft[0], _T("eMule v0.95g")));
	ASSERT(!_tcscmp(S_ModstringSoftI[0], _T("rockesel")));
	ASSERT(!_tcscmp(S_UsernameHard[0], _T("dianlei.com")));
	ASSERT(!_tcscmp(S_UsernameHardI[0], _T("tuotu")));
	ASSERT(!_tcscmp(S_UsernameSoft[0], _T("DONKEY2007")));
	ASSERT(!_tcscmp(S_I0, _T("eMule Compat v0.26.2")));
	ASSERT(!_tcscmp(S_I16, _T("xtreme")));
	ASSERT(!_tcscmp(S_I17, _T(">>Power-Mod")));
	ASSERT(!_tcscmp(S_I20, _T("Plus")));
	ASSERT(!_tcscmp(S_I28, _T("VeryCD")));

	return TRUE;
}

void _DLPOnUnLoad(){
	delete [] __s; __s = NULL;
	delete [] S_array; S_array = NULL;
}

bool IsTypicalHex(LPCTSTR addon,size_t len)
{
	if(len>25 || len<5)
		return false;
	short bigalpha=0;
	short smallalpha=0;
	short numeric=0;

	for(size_t i=0; i<len;i++)
	{
		if( (*addon>=_T('0') && *addon<=_T('9')) )
			numeric++;
		else if( (*addon>=_T('A') && *addon<=_T('F')) )
			bigalpha++;
		else if( (*addon>=_T('a') && *addon<=_T('f')) )
			smallalpha++;
		else
			return false;
		++addon;
	}
	return (numeric>0 &&
			((smallalpha>0 && bigalpha==0) || (smallalpha==0 && bigalpha>0)));
}

bool IsDate(LPCTSTR modversion) // X: check mod strings like date
{
	size_t len = _tcslen(modversion);
	if(*modversion == _T(' ')) // skip the first space
	{
		++modversion;
		--len;
	}
	if((len == 8 && (*modversion++!=_T('2') || *modversion++!=_T('0')))
		|| len!=6)
		return false;
	for(size_t i=0; i<len;i++){
		if( (*modversion<_T('0') || *modversion>_T('9')) )
			return false;
		++modversion;
	}
	return true;
}

__inline TCHAR __ascii_towlower(const TCHAR ch){
    if (( ch >= 'A') && (ch <= 'Z') )
        return ch - 'A' + 'a';
	return ch;
}

void tolowercase(LPTSTR str_lower, LPCTSTR str, size_t len)
{
	size_t i = 0;
	for(; str[i] != 0 && i < len; ++i)
		str_lower[i] = __ascii_towlower(str[i]);
	str_lower[i] = 0;
}

DWORD	_GetDLPVersion(){
	return DLPVERSION;
}

LPCTSTR _DLPCheckUserhash(const PBYTE userhash)
{
	// No more AJ check
	return NULL;
}

//new versions
LPCTSTR _DLPCheckModstring_Hard(LPCTSTR modversion, LPCTSTR clientversion)
{
	if(modversion==NULL || clientversion==NULL)
		return NULL;

	for (size_t i = 0; i<SC_ModstringHard; ++i)
	{
		if(StrStr(modversion, S_ModstringHard[i]))
			return _T("Bad MODSTRING");
	}
	if(StrStr(clientversion, S_I0))
		return L"Flashget";
	if(
		//modstring of XL
		((StrStr(modversion, S_I1) || StrStr(modversion, S_I2) || StrStr(modversion, S_I3)) && StrStr(clientversion, S_I4)) || //should not 0.48a
		(StrStr(modversion, S_I24) && StrStr(clientversion, S_I4)) || //easymule 10#### are not based on .48a
		(StrStr(modversion, S_I25) && StrStr(clientversion,S_I26)) //fake clientversion, should be 0.48a
		//end
	)
		return _T("Fake MODSTRING");
	for (size_t i = 0; i<SC_ModstringHardFake; ++i)
	{
		if(StrStr(modversion, S_ModstringHardFake[i]))
			return _T("Fake MODSTRING");
	}
	//StrStr(modversion, _T("080509")) || StrStr(modversion, _T("20080505")) || 
	//StrStr(modversion, _T("080620")) || StrStr(modversion, _T("080307")) || 
	//StrStr(modversion, _T("20071122")) || StrStr(modversion, _T("20080228")) ||
	if(IsDate(modversion)||
		(_tcsicmp(clientversion, S_I9)==0) || //the client did not send client version
		(modversion[0]!=0 && (StrStrI(clientversion,S_I10) || modversion[0]==_T('['))) ||  //1. donkey user with modstring, 2. modstring begins with [ this is a known leecher
		(modversion[0]!=0 && CString(modversion).TrimRight().IsEmpty()) ||  //pruma, korean leecher, modversion is a space
		(StrStr(modversion, S_I27) && !StrStr(modversion, S_I28)) || //compatible client in china, but no src //tetris
		StrStr(clientversion,S_I11) || //7/2006
		StrStr(clientversion,S_I12) || //8/2006
		StrStr(clientversion,S_I13) //+Ultra
		)
		return _T("Bad MODSTRING");

	TCHAR modversion_lower[256];
	tolowercase(modversion_lower, modversion, _countof(modversion_lower));
	if((StrStr(modversion_lower,S_I5) && StrStr(clientversion,S_I6))||
		(StrStr(modversion_lower,S_I7) && (StrStr(modversion_lower,S_I8) || _tcsrchr(modversion, _T('+')) || _tcsrchr(modversion, _T('×')))) ||
		(StrStr(modversion_lower, S_I14) && StrStrI(clientversion, S_I15) ) || //m_nClientVersion != MAKE_CLIENT_VERSION(0, 42, 4)	// added - Stulle
		(StrStr(modversion_lower, S_I16) && _tcsrchr(modversion, _T(']')))  //bad Xtreme mod
		)
		return _T("Bad MODSTRING");

	for (size_t i = 0; i<SC_ModstringHardI; ++i)
	{
		if(StrStr(modversion_lower, S_ModstringHardI[i]))
			return _T("Bad MODSTRING");
	}

	//WiZaRd Bad Modstring Scheme
	size_t modlen = _tcslen(modversion);
	if( modlen == 0 ||
		(_tcsncmp(modversion, _T("CHN "), 4)==0 && modlen > 8) ||
		(_tcsncmp(modversion, _T("Apollo"), 6)==0) ||  //Apollo is a Portugal Mod
		(_tcsncmp(modversion, _T("sivka"), 5)==0) ||
		(_tcsncmp(modversion, _T("aMule CVS"), 9)==0)
	  )
	{
		;//do nothing
	}
	else
	{
		if(StrStr(clientversion, _T("eMule v")) && (modlen <= 4)) //most of them are fincan
			return L"Bad Modstring Scheme";
		size_t iNumberFound = (size_t)-1;
		bool bNotEnd = false;
		for(size_t i = 0; i < modlen; ++i)
		{
			TCHAR ch = modversion[i]; 
			if( ch == L'.' || ch == L' ')
			{
				bNotEnd = true; //these chars should not be the end of modstring
				iNumberFound = -1; //this is a simple hack to not punish mods like TK4 or Spike2 :)
				continue; //skip "legal" chars
			}
			if( ch == L'-' /*|| ch == L'+'*/ ) //connector characters, connect two string or two numbers
			{
				bNotEnd = true; //these chars should not be the end of modstring
				if(iNumberFound != (size_t)-1) 
					iNumberFound++; //exclude some modstring like v#.#-a1
				continue;
			}
			if(_istdigit(ch)){
				iNumberFound = i;
			}
			else if ( (iNumberFound == i-1) && _istxdigit(ch) ) //abcdef is legal in the end of version number, also exclude bowlfish tk4 and so on
			{
				;//do nothing
			}
			else if( _istpunct(ch) || _istspace(ch) || //illegal punctuation or whitespace character
				//return L"Bad Modstring Scheme";
			/*else if*/(_istcntrl(ch)) || //control character in modstring!?
				//return L"Bad Modstring Scheme";
			/*else if*/(iNumberFound != -1)) //that is: number out of row, e.g. not MorphXT v11.9 but Morph11XT.9
				return L"Bad Modstring Scheme";
			bNotEnd = false;
		}
		if(bNotEnd)
			return L"Bad Modstring Scheme";
	}
	//WiZaRd

	return NULL;
}

LPCTSTR _DLPCheckModstring_Soft(LPCTSTR modversion, LPCTSTR clientversion)
{
	if(modversion==NULL || clientversion==NULL)
		return NULL;

	for (size_t i = 0; i<SC_ModstringSoft; ++i)
	{
		if(StrStr(clientversion, S_ModstringSoft[i]))
			return _T("Bad MODSTRING");
	}

	if(StrStr(modversion, S_I18) || //international filter, change to softban.
		//StrStrI(clientversion, _T("eMule v2.0")) || //6/2007 fake Xtreme / GPL-breaker
		(StrStr(clientversion, S_I19) && StrStr(modversion, S_I20))) //www.lphantplus.com, no src
		return _T("Bad MODSTRING");
	
	TCHAR modversion_lower[256];
	tolowercase(modversion_lower, modversion, _countof(modversion_lower));
	for (size_t i = 0; i<SC_ModstringSoftI; ++i)
	{
		if(StrStr(modversion_lower, S_ModstringSoftI[i]))
			return _T("Bad MODSTRING");
	}

	return NULL;
}

LPCTSTR _DLPCheckUsername_Hard(LPCTSTR username)
{
	if(username==NULL)
		return NULL;

	for (size_t i = 0; i<SC_UsernameHard; ++i)
	{
		if(StrStr(username, S_UsernameHard[i]))
			return _T("Bad USERNAME");
	}
	if(
		//StrStrI(username, _T("emule")) && StrStrI(username, _T("booster")) ||
		//		StrStrI(username, _T("AppleJuice")) && _tcsrchr(username, _T("[")) && _tcsrchr(username, _T("]")) ||
		StrCmpI(username, _T("Muse"))==0 //ketamine mod
	)
		return _T("Bad USERNAME");

	TCHAR username_lower[256];
	tolowercase(username_lower, username, _countof(username_lower));
	for (size_t i = 0; i<SC_UsernameHardI; ++i)
	{
		if(StrStr(username_lower, S_UsernameHardI[i]))
			return _T("Bad USERNAME");
	}

	//new ketamine
	//if(StrStrI(username, _T("[ePlus]")) != StrRStrI(username,NULL, _T("[ePlus]"))) //old version
	size_t userlen = _tcslen(username);
	if(userlen >=14)
	{
		LPCTSTR tempstr=StrStr(username, _T("[ePlus]"));
		if(tempstr && (username + userlen - tempstr) >= 7)
			if(StrStr(tempstr + 7, _T("[ePlus]")))
				return _T("new Ketamine");
	}

	return NULL;
}

LPCTSTR _DLPCheckUsername_Soft(LPCTSTR username)
{
	if(username==NULL)
		return NULL;
	for (size_t i = 0; i<SC_UsernameSoft; ++i)
	{
		if(StrStr(username, S_UsernameSoft[i]))
			return _T("Bad USERNAME");
	}
	if (
		
		//Xman 15.08.05
		StrStrI(username, S_I17)
		//Xman 1/2007 
		/*
		StrStrI(username, _T("AppleJuice [")) && _tcsrchr(username, _T("]")) ||
		StrStrI(username, _T("AppleJuice Mod [")) && _tcsrchr(username, _T("]")) ||
		StrStrI(username, _T("AppleJuice eMule [")) && _tcsrchr(username, _T("]")) //5/2007
		*/
		)
		return _T("Bad USERNAME");

	//bad mods, where every second sign is
	//enough to check two places

	if(_tcslen(username) >=4){
		if(username[3]<=0x1F && username[1]<=0x1F)
			return _T("Community-Username"); //community (based on LSD or it's smasher)

		if(username[0]==_T('v')	&& StrStr(username+1, _T(":com ")))
			return _T("X-Treme");
	}

	return NULL;
}

LPCTSTR _DLPCheckNameAndHashAndMod(CString username, CString& userhash, CString& modversion)
{
	if(username.IsEmpty() || userhash.IsEmpty())
		return NULL;
//zz_fly Start
	//Fake VeryCD
	if((StrStr(modversion,S_I21) || StrStr(modversion,S_I22) )
		&& StrStr(username, S_I23) ) //all fake VeryCD have a default username
		return _T("Fake VeryCD"); 

	//community userhash check
	// X: improved userhash check
	/*static const LPCTSTR refuserhash[] = {
			_T("154CE646120E96CC798C439A20D26F8D") // (windows ue)
			, _T("455361F9D95C3CD7E6BF2192D1CB3D02") // (windows ue)
			, _T("C8B5F41441C615FBABAD9A7E55294D01")
			, _T("A2221641460E961C8B7FF21A53FB6F6C") //**Riso64Bit**
			, _T("888F4742450EF75F9DD8B7E53FA06FF0") //**Riso64Bit**
			, _T("0B76CC42CB0E81B0DC6120D2BCB36FF9") //**Riso64Bit**
		    , _T("EAA383FD9E0E68538C7AC8AD15526F7A") //**Riso64Bit**
			, _T("65C3B2E8940E582630A7F58AF9F26F9E") //from TaiWan
			, _T("9BA09B83DC0EE78BE20280C387936F00") //from SS1900
			, _T("C92859E4860EA0F15F7837750C886FB6") //from SS1900
			, _T("CB42F563EE0EA7907395420CAC146FF5") //From "qobfxb" multi user [DargonD] 
		};
	for(size_t i=0;i<_countof(refuserhash);++i){
		if(_tcsicmp(userhash,refuserhash[i])==0)
			return _T("Community Userhash");
	}*/
	uchar usermd4hash[16];
	wcsmd4(userhash, usermd4hash);

	uchar refuserhash[176] = {
		0x15, 0x4C, 0xE6, 0x46, 0x12, 0x0E, 0x96, 0xCC, 0x79, 0x8C, 0x43, 0x9A, 0x20, 0xD2, 0x6F, 0x8D,  // (windows ue)
		0x45, 0x53, 0x61, 0xF9, 0xD9, 0x5C, 0x3C, 0xD7, 0xE6, 0xBF, 0x21, 0x92, 0xD1, 0xCB, 0x3D, 0x02,  // (windows ue)
		0xC8, 0xB5, 0xF4, 0x14, 0x41, 0xC6, 0x15, 0xFB, 0xAB, 0xAD, 0x9A, 0x7E, 0x55, 0x29, 0x4D, 0x01, 
		0xA2, 0x22, 0x16, 0x41, 0x46, 0x0E, 0x96, 0x1C, 0x8B, 0x7F, 0xF2, 0x1A, 0x53, 0xFB, 0x6F, 0x6C,  //**Riso64Bit**
		0x88, 0x8F, 0x47, 0x42, 0x45, 0x0E, 0xF7, 0x5F, 0x9D, 0xD8, 0xB7, 0xE5, 0x3F, 0xA0, 0x6F, 0xF0,  //**Riso64Bit**
		0x0B, 0x76, 0xCC, 0x42, 0xCB, 0x0E, 0x81, 0xB0, 0xDC, 0x61, 0x20, 0xD2, 0xBC, 0xB3, 0x6F, 0xF9,  //**Riso64Bit**
		0xEA, 0xA3, 0x83, 0xFD, 0x9E, 0x0E, 0x68, 0x53, 0x8C, 0x7A, 0xC8, 0xAD, 0x15, 0x52, 0x6F, 0x7A,  //**Riso64Bit**
		0x65, 0xC3, 0xB2, 0xE8, 0x94, 0x0E, 0x58, 0x26, 0x30, 0xA7, 0xF5, 0x8A, 0xF9, 0xF2, 0x6F, 0x9E, //from TaiWan
		0x9B, 0xA0, 0x9B, 0x83, 0xDC, 0x0E, 0xE7, 0x8B, 0xE2, 0x02, 0x80, 0xC3, 0x87, 0x93, 0x6F, 0x00, //from SS1900
		0xC9, 0x28, 0x59, 0xE4, 0x86, 0x0E, 0xA0, 0xF1, 0x5F, 0x78, 0x37, 0x75, 0x0C, 0x88, 0x6F, 0xB6, //from SS1900
		0xCB, 0x42, 0xF5, 0x63, 0xEE, 0x0E, 0xA7, 0x90, 0x73, 0x95, 0x42, 0x0C, 0xAC, 0x14, 0x6F, 0xF5 //From "qobfxb" multi user [DargonD] 
	};
	for(size_t i=0;i<_countof(refuserhash);i += 16){
		if(md4cmp(usermd4hash, refuserhash + i) == 0)
			return _T("Community Userhash");
	}

	//corrupt userhash check
	/*static const TCHAR refuserhash3[] = _T("00000000000E00000000000000006F00");
	static const TCHAR refuserhash4[] = _T("FE000000000E00000000000000006F00");
	if(_tcsicmp(userhash,refuserhash3)==0 || _tcsicmp(userhash,refuserhash4)==0)*/
	static const uchar refuserhash3[16] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x0E, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x6F, 0x00};
	static const uchar refuserhash4[16] = {0xFE, 0x00, 0x00, 0x00, 0x00, 0x0E, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x6F, 0x00};
	if(md4cmp(usermd4hash,refuserhash3)==0 || md4cmp(usermd4hash,refuserhash4)==0)
		return _T("Corrupt Userhash");

	//community userhash check, thanks SquallATF 
	//static const TCHAR refuserhash5[] = _T("DA1CEEE05B0E5319B3B48CAED24C6F4A");
	//if(_tcsicmp(userhash,refuserhash5)==0)
	static const uchar refuserhash5[16] = {0xDA, 0x1C, 0xEE, 0xE0, 0x5B, 0x0E, 0x53, 0x19, 0xB3, 0xB4, 0x8C, 0xAE, 0xD2, 0x4C, 0x6F, 0x4A};
	if(md4cmp(usermd4hash,refuserhash5)==0)
		return _T("Bad Userhash");
//zz_fly End

	//Check for aedit
	//remark: a unmodded emule can't send a space at last sign
	if(modversion.IsEmpty() && username.Right(1)==32)
		return _T("AEdit");

	//Check for Hex-Modstring
	if(IsTypicalHex(modversion, modversion.GetLength()))
		return _T("Hex-Modstring");

	//community check
	if(username.GetLength()>=7 && username.Right(1)==_T(']'))
	{
		/* no more needed
		//check for gamer
		//two checks should be enough.
		if(username.Right(6).Left(1)==userhash.Mid(5,1)
			&& username.Right(3).Left(1)==userhash.Mid(7,1)
			)
			return _T("old united");
		*/
		
		//check for special nickaddon
		LPCTSTR find = _tcsrchr(username, _T('['));
		if(find != NULL)
		{
			++find;
			size_t endpos=_tcslen(find)-1;
			if(endpos>1)
			{
				//check for snake //12/2006
				/* no more needed, better detection inside Xtreme
				for(int i=0; i<endpos;i++)
				{
					if( !(addon.GetAt(i)>=_T('0') && addon.GetAt(i)<=_T('9')) )
					{
						i=endpos+1;
					}
				}
				if(i==endpos)
					return _T("Snake");
				*/
			
				//Chek for Hex (e.g. X-Treme)
				if(IsTypicalHex(find, endpos))
					return _T("Hex-Code-Addon");
			}
			//zz_fly :: start
			if(endpos == 4){
				for(size_t i=0;i<endpos;i++){
					TCHAR ch = find[i];
					if( _istpunct(ch) || /*_istspace(ch) ||*/ _istcntrl(ch)){
						if(!modversion.IsEmpty() && (_tcsncmp(username, _T("http://emule-project.net ["), 26)==0) && ((find-(LPCTSTR)username)==26))
							return _T("TLH Community"); //username like "http://emule-project.net [random]"
						if(modversion.IsEmpty() && (_tcschr(username, _T('['))==find-1))
							return _T("GhostMod"); //username has a random padding [random], it should be a mod function, but there is no modstring
						if((_tcsncmp(username, _T("Silver Surfer User"), 18)==0) && (StrStr(modversion, _T("Silver"))==NULL))
							return _T("Fake Silver Surfer"); //**Riso64Bit** :: fake silver surfer
						break;
					}
				}
			}
			//zz_fly :: end
		}
	}

	//thx cyrex
	if(modversion.GetLength() == 10 && username.GetLength()>4 &&  StrStr(username.Right(4), _T("/]"))  && StrStr(username, _T("[SE]")))
		return _T("Mystery ModString");

	if(modversion.IsEmpty())
		return NULL;
	
	static const LPCTSTR testModString[] = {_T("Xtreme"), _T("ScarAngel"), _T("Mephisto"), _T("MorphXT"), _T("EastShare"), _T("StulleMule"), /*_T("Magic Angel"),*/ _T("DreaMule"), _T("X-Mod"), _T("RaJiL")};
	static const float testMinVer[] = {4.4f, 2.5f, 1.5f, 10.0f, 13.0f, 6.0f, /*3.0f,*/ 3.0f, 0.0f, 2.2f};
	ASSERT(_countof(testModString) == _countof(testMinVer));
	for(size_t i=0; i<_countof(testModString); i++){
		bool tag1 = (username.Find(CString(_T('«')) + testModString[i]) != -1);
		if(modversion.Find(testModString[i]) != -1) {
			if(!tag1){
				if(testMinVer[i] == 0.0f)
					return _T("ModString Thief");
				float version = (float)_tstof(modversion.Right(4));
				if((version == 9.7f) || (version >= testMinVer[i]))
					return _T("ModString Thief");
			}
		}
		else if(tag1)
			return _T("ModString Thief");
	}

	//doubled  «...» in the username, like "username «Xtreme #.#» «abcd»"
	int posr1 = username.Find(_T('»'));
	int posr2 = username.ReverseFind(_T('»'));
	if((posr1 > 5) && (posr2 - posr1 > 5) && ((username.GetAt(posr1 - 5) == _T('«')) || (username.GetAt(posr2 - 5) == _T('«'))))
		return _T("Bad Username Paddings");
	//zz_fly :: end

	return NULL; 
}

LPCTSTR _DLPCheckMessageSpam(LPCTSTR messagetext)
{
	if(messagetext==NULL)
		return NULL;

	static const LPCTSTR S_MT[] = {
		_T("ZamBoR")
		, _T("DI-Emule")
		, _T("Join the L33cher")
		, _T("eMule FX")
		, _T("---> ed2k://|file|Ketamine")
		, _T("robot from RIAA, you can't fight")
		, _T("agent from PeerFactor, she advises you to stop")
		, _T("bot from MPAA, you can't do anything against her")
		, _T("[Sangue-Suga]") //3 /2007
		, _T("[te@m projekt") //5 /2007
		, _T("eMule PRO Ultra") //8/2007 //include ultra 1 2 3
		, _T("HyperMule") //8/2007
		, _T("FXeMule")
		, _T("angelmule.com") //**Riso64Bit**
		, _T("RocketMule") //**Riso64Bit**
	};
	for (size_t i = 0; i<_countof(S_MT); ++i)
	{
		if(StrStr(messagetext, S_MT[i]))
			return _T("Spam-Message");
	}

	if(CString(messagetext).TrimRight().IsEmpty())
		return (_T("Spam-Message"));

	return NULL;
}

LPCTSTR _DLPCheckHelloTag(UINT tagnumber)
{
	switch(tagnumber)
	{
		case CT_UNKNOWNx12:
		case CT_UNKNOWNx13:
		case CT_UNKNOWNx14:
		case CT_UNKNOWNx16:
		case CT_UNKNOWNx17:
		case CT_UNKNOWNxE6:			return apszSnafuTag[0];//buffer=_T("DodgeBoards");break;
		case CT_UNKNOWNx15:			return apszSnafuTag[1];//buffer=_T("DodgeBoards & DarkMule |eVorte|X|");break;
		case CT_UNKNOWNx22:			return apszSnafuTag[2];//buffer=_T("DarkMule v6 |eVorte|X|");break;
		case CT_UNKNOWNx5D:
		case CT_UNKNOWNx6B:
		case CT_UNKNOWNx6C:			//return apszSnafuTag[17];
		case CT_UNKNOWNx74:
		case CT_UNKNOWNx87:			//return apszSnafuTag[17];
		case CT_UNKNOWNxF0:
		case CT_UNKNOWNxF4:			return apszSnafuTag[17];
			//case CT_UNKNOWNx69:			return apszSnafuTag[3];//buffer=_T("eMuleReactor");break;
		case CT_UNKNOWNx79:			return apszSnafuTag[4];//buffer=_T("Bionic");break;
		case CT_UNKNOWNx83:			return apszSnafuTag[15];//buffer=_T("Fusspi");break;
		case CT_UNKNOWNx76:			
		case CT_UNKNOWNxCD:			return apszSnafuTag[16];//buffer=_T("www.donkey2002.to");break;
		case CT_UNKNOWNx88:			//return apszSnafuTag[5];//[LSD7c]
		case CT_UNKNOWNx8c:			return apszSnafuTag[5];//buffer=_T("[LSD7c]");break; 
		case CT_UNKNOWNx8d:			return apszSnafuTag[6];//buffer=_T("[0x8d] unknown Leecher - (client version:60)");break;
		case CT_UNKNOWNx99:			return apszSnafuTag[7];//buffer=_T("[RAMMSTEIN]");break;		//STRIKE BACK
		case CT_UNKNOWNx97:
		case CT_UNKNOWNx98:
		case CT_UNKNOWNx9C:
		case CT_UNKNOWNxDA:			return apszSnafuTag[3];//buffer=_T("eMuleReactor");break;
		case CT_UNKNOWNxC8:			//Xman x4
		case CT_UNKNOWNxCE:			//Xman 20.08.05
		case CT_UNKNOWNxCF:			//Xman 20.08.05
		case CT_UNKNOWNx94:			//Xman 20.08.05
		case CT_UNKNOWNxc4:			return apszSnafuTag[8];//buffer=_T("[MD5 Community]");break;	//USED BY NEW BIONIC => 0x12 Sender
		case CT_UNKNOWNxEC:			return apszSnafuTag[18]; //Xman x4 Speedmule
		//case CT_FRIENDSHARING:		//STRIKE BACK	//break;
		case CT_DARK:				//STRIKE BACK
		case CT_UNKNOWNx7A:
		case CT_UNKNOWNxCA:			return apszSnafuTag[9];//buffer=_T("new DarkMule");
		case CT_UNKNOWNx4D:			return apszSnafuTag[19];// pimp my mule misuse an official tag in hello
		case CT_UNKNOWNxD2:			return apszSnafuTag[20];//SquallATF
		//case CT_UNKNOWNx85:			return apszSnafuTag[21];//zz_fly
	}

	return NULL;
}

LPCTSTR _DLPCheckInfoTag(UINT tagnumber)
{
	switch(tagnumber)
	{
		case ET_MOD_UNKNOWNx12:
		case ET_MOD_UNKNOWNx13:
		case ET_MOD_UNKNOWNx14:
		case ET_MOD_UNKNOWNx17:		return apszSnafuTag[0];//("[DodgeBoards]")
		case ET_MOD_UNKNOWNx2F:		return apszSnafuTag[10];//buffer=_T("[OMEGA v.07 Heiko]");break;
		case ET_MOD_UNKNOWNx36:
		case ET_MOD_UNKNOWNx5B:
		case ET_MOD_UNKNOWNxA6:		return apszSnafuTag[11];//buffer=_T("eMule v0.26 Leecher");break;
		case ET_MOD_UNKNOWNx60:		return apszSnafuTag[12];//buffer=_T("[Hunter]");break; //STRIKE BACK
		case ET_MOD_UNKNOWNx76:		return apszSnafuTag[0];//buffer=_T("[DodgeBoards]");break;
		case ET_MOD_UNKNOWNx50:		
		case ET_MOD_UNKNOWNxB1:		
		case ET_MOD_UNKNOWNxB4:		
		case ET_MOD_UNKNOWNxC8:		
		case ET_MOD_UNKNOWNxC9:		return apszSnafuTag[13];//buffer=_T("[Bionic 0.20 Beta]");break;
		case ET_MOD_UNKNOWNxDA:		return apszSnafuTag[14];//buffer=_T("[Rumata (rus)(Plus v1f)]");break;
	}
	return NULL;
}
